Subject: bug#56682: Fix the long lines font locking related slowdowns

From: Stefan Monnier <[email-masked]>
Date: Fri, 12 Aug 2022 22:01:54 -0400

> I can only repeat that the only ways to improve font locking in a non-local
> way (or at least, the only ways that were identified in the discussions so
> far) are either to improve the speed of syntax-ppss by an order of
> magnitude, in which case it would perhaps become feasible to allow
> syntax-ppss to have access to the whole buffer, or to equip syntax-ppss with
> heuristics to make it work "as well as possible" even when it only has
> access to a portion of the buffer.

But the locked narrowing is applied based on the presence of long-lines
rather than based on the total size of the buffer.

I think we'll want to decouple the two because they aren't quite the
same (e.g. in many cases the time taken by `syntax-ppss` doesn't depend
on the length of lines, whereas the time taken by `font-lock-keywords`
rues does not depend on the total buffer size).

        Stefan